package wtf.hak.survivalfabric.mixin.client;

import net.minecraft.block.entity.BlockEntity;
import net.minecraft.client.render.block.entity.BlockEntityRenderer;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import wtf.hak.survivalfabric.config.client.ClientConfigManager;

@Mixin(BlockEntityRenderer.class)
public interface BlockEntityRendererMixin<T extends BlockEntity> {

    @Inject(method = "getRenderDistance", at = @At("HEAD"), cancellable = true)
    private void getRenderDistance(CallbackInfoReturnable<Integer> cir) {
        if (ClientConfigManager.getConfig().manipulateBlockEntityDistance)
            cir.setReturnValue(ClientConfigManager.getConfig().blockEntityRange);
    }
}
