package wtf.hak.survivalfabric.mixin.client;

import net.minecraft.client.network.ClientPlayerEntity;
import net.minecraft.entity.Entity;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import wtf.hak.survivalfabric.config.client.ClientConfigManager;
import wtf.hak.survivalfabric.features.AngleViewer;

@Mixin(Entity.class)
public abstract class EntityMixin {

    @Inject(method = "setYaw", at = @At("HEAD"), cancellable = true)
    private void preventYawChange(float yaw, CallbackInfo ci) {
        if ((Object) this instanceof ClientPlayerEntity player) {
            if (player.isMainPlayer() && AngleViewer.PREVENT_HEAD_MOVEMENT && ClientConfigManager.getConfig().lockTeleportHeadMovement) {
                ci.cancel();
            }
        }
    }

    @Inject(method = "setPitch", at = @At("HEAD"), cancellable = true)
    private void preventPitchChange(float pitch, CallbackInfo ci) {
        if ((Object) this instanceof ClientPlayerEntity player) {
            if (player.isMainPlayer() && AngleViewer.PREVENT_HEAD_MOVEMENT && ClientConfigManager.getConfig().lockTeleportHeadMovement) {
                ci.cancel();
            }
        }
    }
}
