package wtf.hak.survivalfabric.mixin.client;

import net.minecraft.client.MinecraftClient;
import net.minecraft.client.Mouse;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import wtf.hak.survivalfabric.features.Zoom;

import static wtf.hak.survivalfabric.config.client.ClientConfigManager.getConfig;

@Mixin(Mouse.class)
public class MouseMixin {

    /**
     * Scrolling listener for zooming
     */
    @Inject(method = "onMouseScroll", at = @At("HEAD"), cancellable = true)
    private void onMouseScroll(long window, double horizontal, double vertical, CallbackInfo ci) {
        if (Zoom.isZooming() && getConfig().scrollToZoom) {
            if (MinecraftClient.getInstance().player != null) {
                if (vertical > 0)
                    Zoom.modifyStep(-1);
                else
                    Zoom.modifyStep(1);
            }
            ci.cancel();
        }
    }


}
